rio-0.1.22.0: A standard library for Haskell

Safe Haskell | Safe-Inferred
Language | Haskell2010

RIO.Vector.Storable

Contents

- Storable vectors
- Accessors
  - Length information
  - Indexing
  - Extracting subvectors
- Construction
  - Initialisation
  - Monadic initialisation
  - Unfolding
  - Enumeration
  - Concatenation
  - Restricting memory usage
- Modifying vectors
  - Permutations
  - Safe destructive update
- Elementwise operations
  - Mapping
  - Monadic mapping
  - Zipping
  - Monadic zipping
- Working with predicates
  - Filtering
  - Partitioning
  - Searching
- Folding
  - Specialised folds
  - Monadic folds
- Prefix sums (scans)
- Conversions
  - Lists
  - Different vector types
  - Mutable vectors

Description

Storable `Vector`. Import as:

    import qualified RIO.Vector.Storable as VS

This module does not export any partial or unsafe functions. For those, see RIO.Vector.Storable.Partial and RIO.Vector.Storable.Unsafe

Synopsis

- data Vector a
- data MVector s a = MVector !Int !(ForeignPtr a)
- class Storable a
- length :: Storable a => Vector a -> Int
- null :: Storable a => Vector a -> Bool
- (!?) :: Storable a => Vector a -> Int -> Maybe a
- slice :: Storable a => Int -> Int -> Vector a -> Vector a
- take :: Storable a => Int -> Vector a -> Vector a
- drop :: Storable a => Int -> Vector a -> Vector a
- splitAt :: Storable a => Int -> Vector a -> (Vector a, Vector a)
- empty :: Storable a => Vector a
- singleton :: Storable a => a -> Vector a
- replicate :: Storable a => Int -> a -> Vector a
- generate :: Storable a => Int -> (Int -> a) -> Vector a
- iterateN :: Storable a => Int -> (a -> a) -> a -> Vector a
- replicateM :: (Monad m, Storable a) => Int -> m a -> m (Vector a)
- generateM :: (Monad m, Storable a) => Int -> (Int -> m a) -> m (Vector a)
- iterateNM :: (Monad m, Storable a) => Int -> (a -> m a) -> a -> m (Vector a)
- create :: Storable a => (forall s. ST s (MVector s a)) -> Vector a
- createT :: (Traversable f, Storable a) => (forall s. ST s (f (MVector s a))) -> f (Vector a)
- unfoldr :: Storable a => (b -> Maybe (a, b)) -> b -> Vector a
- unfoldrN :: Storable a => Int -> (b -> Maybe (a, b)) -> b -> Vector a
- unfoldrM :: (Monad m, Storable a) => (b -> m (Maybe (a, b))) -> b -> m (Vector a)
- unfoldrNM :: (Monad m, Storable a) => Int -> (b -> m (Maybe (a, b))) -> b -> m (Vector a)
- constructN :: Storable a => Int -> (Vector a -> a) -> Vector a
- constructrN :: Storable a => Int -> (Vector a -> a) -> Vector a
- enumFromN :: (Storable a, Num a) => a -> Int -> Vector a
- enumFromStepN :: (Storable a, Num a) => a -> a -> Int -> Vector a
- enumFromTo :: (Storable a, Enum a) => a -> a -> Vector a
- enumFromThenTo :: (Storable a, Enum a) => a -> a -> a -> Vector a
- cons :: Storable a => a -> Vector a -> Vector a
- snoc :: Storable a => Vector a -> a -> Vector a
- (++) :: Storable a => Vector a -> Vector a -> Vector a
- concat :: Storable a => [Vector a] -> Vector a
- force :: Storable a => Vector a -> Vector a
- reverse :: Storable a => Vector a -> Vector a
- modify :: Storable a => (forall s. MVector s a -> ST s ()) -> Vector a -> Vector a
- map :: (Storable a, Storable b) => (a -> b) -> Vector a -> Vector b
- imap :: (Storable a, Storable b) => (Int -> a -> b) -> Vector a -> Vector b
- concatMap :: (Storable a, Storable b) => (a -> Vector b) -> Vector a -> Vector b
- mapM :: (Monad m, Storable a, Storable b) => (a -> m b) -> Vector a -> m (Vector b)
- mapM_ :: (Monad m, Storable a) => (a -> m b) -> Vector a -> m ()
- forM :: (Monad m, Storable a, Storable b) => Vector a -> (a -> m b) -> m (Vector b)
- forM_ :: (Monad m, Storable a) => Vector a -> (a -> m b) -> m ()
- zipWith :: (Storable a, Storable b, Storable c) => (a -> b -> c) -> Vector a -> Vector b -> Vector c
- zipWith3 :: (Storable a, Storable b, Storable c, Storable d) => (a -> b -> c -> d) -> Vector a -> Vector b -> Vector c -> Vector d
- zipWith4 :: (Storable a, Storable b, Storable c, Storable d, Storable e) => (a -> b -> c -> d -> e) -> Vector a -> Vector b -> Vector c -> Vector d -> Vector e
- zipWith5 :: (Storable a, Storable b, Storable c, Storable d, Storable e, Storable f) => (a -> b -> c -> d -> e -> f) -> Vector a -> Vector b -> Vector c -> Vector d -> Vector e -> Vector f
- zipWith6 :: (Storable a, Storable b, Storable c, Storable d, Storable e, Storable f, Storable g) => (a -> b -> c -> d -> e -> f -> g) -> Vector a -> Vector b -> Vector c -> Vector d -> Vector e -> Vector f -> Vector g
- izipWith :: (Storable a, Storable b, Storable c) => (Int -> a -> b -> c) -> Vector a -> Vector b -> Vector c
- izipWith3 :: (Storable a, Storable b, Storable c, Storable d) => (Int -> a -> b -> c -> d) -> Vector a -> Vector b -> Vector c -> Vector d
- izipWith4 :: (Storable a, Storable b, Storable c, Storable d, Storable e) => (Int -> a -> b -> c -> d -> e) -> Vector a -> Vector b -> Vector c -> Vector d -> Vector e
- izipWith5 :: (Storable a, Storable b, Storable c, Storable d, Storable e, Storable f) => (Int -> a -> b -> c -> d -> e -> f) -> Vector a -> Vector b -> Vector c -> Vector d -> Vector e -> Vector f
- izipWith6 :: (Storable a, Storable b, Storable c, Storable d, Storable e, Storable f, Storable g) => (Int -> a -> b -> c -> d -> e -> f -> g) -> Vector a -> Vector b -> Vector c -> Vector d -> Vector e -> Vector f -> Vector g
- zipWithM :: (Monad m, Storable a, Storable b, Storable c) => (a -> b -> m c) -> Vector a -> Vector b -> m (Vector c)
- zipWithM_ :: (Monad m, Storable a, Storable b) => (a -> b -> m c) -> Vector a -> Vector b -> m ()
- filter :: Storable a => (a -> Bool) -> Vector a -> Vector a
- ifilter :: Storable a => (Int -> a -> Bool) -> Vector a -> Vector a
- uniq :: (Storable a, Eq a) => Vector a -> Vector a
- mapMaybe :: (Storable a, Storable b) => (a -> Maybe b) -> Vector a -> Vector b
- imapMaybe :: (Storable a, Storable b) => (Int -> a -> Maybe b) -> Vector a -> Vector b
- filterM :: (Monad m, Storable a) => (a -> m Bool) -> Vector a -> m (Vector a)
- takeWhile :: Storable a => (a -> Bool) -> Vector a -> Vector a
- dropWhile :: Storable a => (a -> Bool) -> Vector a -> Vector a
- partition :: Storable a => (a -> Bool) -> Vector a -> (Vector a, Vector a)
- unstablePartition :: Storable a => (a -> Bool) -> Vector a -> (Vector a, Vector a)
- span :: Storable a => (a -> Bool) -> Vector a -> (Vector a, Vector a)
- break :: Storable a => (a -> Bool) -> Vector a -> (Vector a, Vector a)
- elem :: (Storable a, Eq a) => a -> Vector a -> Bool
- notElem :: (Storable a, Eq a) => a -> Vector a -> Bool
- find :: Storable a => (a -> Bool) -> Vector a -> Maybe a
- findIndex :: Storable a => (a -> Bool) -> Vector a -> Maybe Int
- findIndices :: Storable a => (a -> Bool) -> Vector a -> Vector Int
- elemIndex :: (Storable a, Eq a) => a -> Vector a -> Maybe Int
- elemIndices :: (Storable a, Eq a) => a -> Vector a -> Vector Int
- foldl :: Storable b => (a -> b -> a) -> a -> Vector b -> a
- foldl' :: Storable b => (a -> b -> a) -> a -> Vector b -> a
- foldr :: Storable a => (a -> b -> b) -> b -> Vector a -> b
- foldr' :: Storable a => (a -> b -> b) -> b -> Vector a -> b
- ifoldl :: Storable b => (a -> Int -> b -> a) -> a -> Vector b -> a
- ifoldl' :: Storable b => (a -> Int -> b -> a) -> a -> Vector b -> a
- ifoldr :: Storable a => (Int -> a -> b -> b) -> b -> Vector a -> b
- ifoldr' :: Storable a => (Int -> a -> b -> b) -> b -> Vector a -> b
- all :: Storable a => (a -> Bool) -> Vector a -> Bool
- any :: Storable a => (a -> Bool) -> Vector a -> Bool
- and :: Vector Bool -> Bool
- or :: Vector Bool -> Bool
- sum :: (Storable a, Num a) => Vector a -> a
- product :: (Storable a, Num a) => Vector a -> a
- foldM :: (Monad m, Storable b) => (a -> b -> m a) -> a -> Vector b -> m a
- foldM' :: (Monad m, Storable b) => (a -> b -> m a) -> a -> Vector b -> m a
- foldM_ :: (Monad m, Storable b) => (a -> b -> m a) -> a -> Vector b -> m ()
- foldM'_ :: (Monad m, Storable b) => (a -> b -> m a) -> a -> Vector b -> m ()
- prescanl :: (Storable a, Storable b) => (a -> b -> a) -> a -> Vector b -> Vector a
- prescanl' :: (Storable a, Storable b) => (a -> b -> a) -> a -> Vector b -> Vector a
- postscanl :: (Storable a, Storable b) => (a -> b -> a) -> a -> Vector b -> Vector a
- postscanl' :: (Storable a, Storable b) => (a -> b -> a) -> a -> Vector b -> Vector a
- scanl :: (Storable a, Storable b) => (a -> b -> a) -> a -> Vector b -> Vector a
- scanl' :: (Storable a, Storable b) => (a -> b -> a) -> a -> Vector b -> Vector a
- prescanr :: (Storable a, Storable b) => (a -> b -> b) -> b -> Vector a -> Vector b
- prescanr' :: (Storable a, Storable b) => (a -> b -> b) -> b -> Vector a -> Vector b
- postscanr :: (Storable a, Storable b) => (a -> b -> b) -> b -> Vector a -> Vector b
- postscanr' :: (Storable a, Storable b) => (a -> b -> b) -> b -> Vector a -> Vector b
- scanr :: (Storable a, Storable b) => (a -> b -> b) -> b -> Vector a -> Vector b
- scanr' :: (Storable a, Storable b) => (a -> b -> b) -> b -> Vector a -> Vector b
- toList :: Storable a => Vector a -> [a]
- fromList :: Storable a => [a] -> Vector a
- fromListN :: Storable a => Int -> [a] -> Vector a
- convert :: (Vector v a, Vector w a) => v a -> w a
- freeze :: (Storable a, PrimMonad m) => MVector (PrimState m) a -> m (Vector a)
- thaw :: (Storable a, PrimMonad m) => Vector a -> m (MVector (PrimState m) a)
- copy :: (Storable a, PrimMonad m) => MVector (PrimState m) a -> Vector a -> m ()

# Storable vectors

data Vector a Source #

`Storable`-based vectors.

#### Instances

Instances details

NFData1 Vector | Since: vector-0.12.1.0
Instance details Defined in Data.Vector.Storable Methods liftRnf :: (a -> ()) -> Vector a -> () Source #
Storable a => Vector Vector a |

Instance details

Defined in Data.Vector.Storable

Methods

basicUnsafeFreeze :: Mutable Vector s a -> ST s (Vector a) Source #

basicUnsafeThaw :: Vector a -> ST s (Mutable Vector s a) Source #

basicLength :: Vector a -> Int Source #

basicUnsafeSlice :: Int -> Int -> Vector a -> Vector a Source #

basicUnsafeIndexM :: Vector a -> Int -> Box a Source #

basicUnsafeCopy :: Mutable Vector s a -> Vector a -> ST s () Source #

elemseq :: Vector a -> a -> b -> b Source #

(Data a, Storable a) => Data (Vector a) |

Instance details

Defined in Data.Vector.Storable

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> Vector a -> c (Vector a) Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c (Vector a) Source #

toConstr :: Vector a -> Constr Source #

dataTypeOf :: Vector a -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c (Vector a)) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c (Vector a)) Source #

gmapT :: (forall b. Data b => b -> b) -> Vector a -> Vector a Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> Vector a -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> Vector a -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> Vector a -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> Vector a -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> Vector a -> m (Vector a) Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> Vector a -> m (Vector a) Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> Vector a -> m (Vector a) Source #

Storable a => Monoid (Vector a) |
Instance details Defined in Data.Vector.Storable Methods mempty :: Vector a Source # mappend :: Vector a -> Vector a -> Vector a Source # mconcat :: [Vector a] -> Vector a Source #
Storable a => Semigroup (Vector a) |
Instance details Defined in Data.Vector.Storable Methods (<>) :: Vector a -> Vector a -> Vector a Source # sconcat :: NonEmpty (Vector a) -> Vector a Source # stimes :: Integral b => b -> Vector a -> Vector a Source #
Storable a => IsList (Vector a) |
Instance details Defined in Data.Vector.Storable Associated Types type Item (Vector a) Source # Methods fromList :: [Item (Vector a)] -> Vector a Source # fromListN :: Int -> [Item (Vector a)] -> Vector a Source # toList :: Vector a -> [Item (Vector a)] Source #
(Read a, Storable a) => Read (Vector a) |
Instance details Defined in Data.Vector.Storable Methods readsPrec :: Int -> ReadS (Vector a) Source # readList :: ReadS [Vector a] Source # readPrec :: ReadPrec (Vector a) Source # readListPrec :: ReadPrec [Vector a] Source #
(Show a, Storable a) => Show (Vector a) |
Instance details Defined in Data.Vector.Storable Methods showsPrec :: Int -> Vector a -> ShowS Source # show :: Vector a -> String Source # showList :: [Vector a] -> ShowS Source #
NFData (Vector a) |
Instance details Defined in Data.Vector.Storable Methods rnf :: Vector a -> () Source #
(Storable a, Eq a) => Eq (Vector a) |
Instance details Defined in Data.Vector.Storable Methods (==) :: Vector a -> Vector a -> Bool Source # (/=) :: Vector a -> Vector a -> Bool Source #
(Storable a, Ord a) => Ord (Vector a) |
Instance details Defined in Data.Vector.Storable Methods compare :: Vector a -> Vector a -> Ordering Source # (<) :: Vector a -> Vector a -> Bool Source # (<=) :: Vector a -> Vector a -> Bool Source # (>) :: Vector a -> Vector a -> Bool Source # (>=) :: Vector a -> Vector a -> Bool Source # max :: Vector a -> Vector a -> Vector a Source # min :: Vector a -> Vector a -> Vector a Source #
type Mutable Vector |
Instance details Defined in Data.Vector.Storable type Mutable Vector = MVector
type Item (Vector a) |
Instance details Defined in Data.Vector.Storable type Item (Vector a) = a

data MVector s a Source #

Mutable `Storable`-based vectors.

Constructors

MVector !Int !(ForeignPtr a) |

#### Instances

Instances details

Storable a => MVector MVector a |

Instance details

Defined in Data.Vector.Storable.Mutable

Methods

basicLength :: MVector s a -> Int Source #

basicUnsafeSlice :: Int -> Int -> MVector s a -> MVector s a Source #

basicOverlaps :: MVector s a -> MVector s a -> Bool Source #

basicUnsafeNew :: Int -> ST s (MVector s a) Source #

basicInitialize :: MVector s a -> ST s () Source #

basicUnsafeReplicate :: Int -> a -> ST s (MVector s a) Source #

basicUnsafeRead :: MVector s a -> Int -> ST s a Source #

basicUnsafeWrite :: MVector s a -> Int -> a -> ST s () Source #

basicClear :: MVector s a -> ST s () Source #

basicSet :: MVector s a -> a -> ST s () Source #

basicUnsafeCopy :: MVector s a -> MVector s a -> ST s () Source #

basicUnsafeMove :: MVector s a -> MVector s a -> ST s () Source #

basicUnsafeGrow :: MVector s a -> Int -> ST s (MVector s a) Source #

NFData1 (MVector s) |
Instance details Defined in Data.Vector.Storable.Mutable Methods liftRnf :: (a -> ()) -> MVector s a -> () Source #
NFData (MVector s a) |
Instance details Defined in Data.Vector.Storable.Mutable Methods rnf :: MVector s a -> () Source #

class Storable a Source #

The member functions of this class facilitate writing values of primitive types to raw memory (which may have been allocated with the above mentioned routines) and reading values from blocks of raw memory. The class, furthermore, includes support for computing the storage requirements and alignment restrictions of storable types.

Memory addresses are represented as values of type ``Ptr` a`, for some `a` which is an instance of class `Storable`. The type argument to `Ptr` helps provide some valuable type safety in FFI code (you can't mix pointers of different types without an explicit cast), while helping the Haskell type system figure out which marshalling method is needed for a given pointer.

All marshalling between Haskell and a foreign language ultimately boils down to translating Haskell data structures into the binary representation of a corresponding data structure of the foreign language and vice versa. To code this marshalling in Haskell, it is necessary to manipulate primitive data types stored in unstructured memory blocks. The class `Storable` facilitates this manipulation on all types for which it is instantiated, which are the standard basic types of Haskell, the fixed size `Int` types (`Int8`, `Int16`, `Int32`, `Int64`), the fixed size `Word` types (`Word8`, `Word16`, `Word32`, `Word64`), `StablePtr`, all types from Foreign.C.Types, as well as `Ptr`.

Minimal complete definition

sizeOf, alignment, (peek | peekElemOff | peekByteOff), (poke | pokeElemOff | pokeByteOff)

#### Instances

Instances details

Storable CBool |

Instance details

Defined in Foreign.C.Types

Methods

sizeOf :: CBool -> Int Source #

alignment :: CBool -> Int Source #

peekElemOff :: Ptr CBool -> Int -> IO CBool Source #

pokeElemOff :: Ptr CBool -> Int -> CBool -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CBool Source #

pokeByteOff :: Ptr b -> Int -> CBool -> IO () Source #

peek :: Ptr CBool -> IO CBool Source #

poke :: Ptr CBool -> CBool -> IO () Source #

Storable CChar |

Instance details

Defined in Foreign.C.Types

Methods

sizeOf :: CChar -> Int Source #

alignment :: CChar -> Int Source #

peekElemOff :: Ptr CChar -> Int -> IO CChar Source #

pokeElemOff :: Ptr CChar -> Int -> CChar -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CChar Source #

pokeByteOff :: Ptr b -> Int -> CChar -> IO () Source #

peek :: Ptr CChar -> IO CChar Source #

poke :: Ptr CChar -> CChar -> IO () Source #

Storable CClock |

Instance details

Defined in Foreign.C.Types

Methods

sizeOf :: CClock -> Int Source #

alignment :: CClock -> Int Source #

peekElemOff :: Ptr CClock -> Int -> IO CClock Source #

pokeElemOff :: Ptr CClock -> Int -> CClock -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CClock Source #

pokeByteOff :: Ptr b -> Int -> CClock -> IO () Source #

peek :: Ptr CClock -> IO CClock Source #

poke :: Ptr CClock -> CClock -> IO () Source #

Storable CDouble |

Instance details

Defined in Foreign.C.Types

Methods

sizeOf :: CDouble -> Int Source #

alignment :: CDouble -> Int Source #

peekElemOff :: Ptr CDouble -> Int -> IO CDouble Source #

pokeElemOff :: Ptr CDouble -> Int -> CDouble -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CDouble Source #

pokeByteOff :: Ptr b -> Int -> CDouble -> IO () Source #

peek :: Ptr CDouble -> IO CDouble Source #

poke :: Ptr CDouble -> CDouble -> IO () Source #

Storable CFloat |

Instance details

Defined in Foreign.C.Types

Methods

sizeOf :: CFloat -> Int Source #

alignment :: CFloat -> Int Source #

peekElemOff :: Ptr CFloat -> Int -> IO CFloat Source #

pokeElemOff :: Ptr CFloat -> Int -> CFloat -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CFloat Source #

pokeByteOff :: Ptr b -> Int -> CFloat -> IO () Source #

peek :: Ptr CFloat -> IO CFloat Source #

poke :: Ptr CFloat -> CFloat -> IO () Source #

Storable CInt |

Instance details

Defined in Foreign.C.Types

Methods

sizeOf :: CInt -> Int Source #

alignment :: CInt -> Int Source #

peekElemOff :: Ptr CInt -> Int -> IO CInt Source #

pokeElemOff :: Ptr CInt -> Int -> CInt -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CInt Source #

pokeByteOff :: Ptr b -> Int -> CInt -> IO () Source #

peek :: Ptr CInt -> IO CInt Source #

poke :: Ptr CInt -> CInt -> IO () Source #

Storable CIntMax |

Instance details

Defined in Foreign.C.Types

Methods

sizeOf :: CIntMax -> Int Source #

alignment :: CIntMax -> Int Source #

peekElemOff :: Ptr CIntMax -> Int -> IO CIntMax Source #

pokeElemOff :: Ptr CIntMax -> Int -> CIntMax -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CIntMax Source #

pokeByteOff :: Ptr b -> Int -> CIntMax -> IO () Source #

peek :: Ptr CIntMax -> IO CIntMax Source #

poke :: Ptr CIntMax -> CIntMax -> IO () Source #

Storable CIntPtr |

Instance details

Defined in Foreign.C.Types

Methods

sizeOf :: CIntPtr -> Int Source #

alignment :: CIntPtr -> Int Source #

peekElemOff :: Ptr CIntPtr -> Int -> IO CIntPtr Source #

pokeElemOff :: Ptr CIntPtr -> Int -> CIntPtr -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CIntPtr Source #

pokeByteOff :: Ptr b -> Int -> CIntPtr -> IO () Source #

peek :: Ptr CIntPtr -> IO CIntPtr Source #

poke :: Ptr CIntPtr -> CIntPtr -> IO () Source #

Storable CLLong |

Instance details

Defined in Foreign.C.Types

Methods

sizeOf :: CLLong -> Int Source #

alignment :: CLLong -> Int Source #

peekElemOff :: Ptr CLLong -> Int -> IO CLLong Source #

pokeElemOff :: Ptr CLLong -> Int -> CLLong -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CLLong Source #

pokeByteOff :: Ptr b -> Int -> CLLong -> IO () Source #

peek :: Ptr CLLong -> IO CLLong Source #

poke :: Ptr CLLong -> CLLong -> IO () Source #

Storable CLong |

Instance details

Defined in Foreign.C.Types

Methods

sizeOf :: CLong -> Int Source #

alignment :: CLong -> Int Source #

peekElemOff :: Ptr CLong -> Int -> IO CLong Source #

pokeElemOff :: Ptr CLong -> Int -> CLong -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CLong Source #

pokeByteOff :: Ptr b -> Int -> CLong -> IO () Source #

peek :: Ptr CLong -> IO CLong Source #

poke :: Ptr CLong -> CLong -> IO () Source #

Storable CPtrdiff |

Instance details

Defined in Foreign.C.Types

Methods

sizeOf :: CPtrdiff -> Int Source #

alignment :: CPtrdiff -> Int Source #

peekElemOff :: Ptr CPtrdiff -> Int -> IO CPtrdiff Source #

pokeElemOff :: Ptr CPtrdiff -> Int -> CPtrdiff -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CPtrdiff Source #

pokeByteOff :: Ptr b -> Int -> CPtrdiff -> IO () Source #

peek :: Ptr CPtrdiff -> IO CPtrdiff Source #

poke :: Ptr CPtrdiff -> CPtrdiff -> IO () Source #

Storable CSChar |

Instance details

Defined in Foreign.C.Types

Methods

sizeOf :: CSChar -> Int Source #

alignment :: CSChar -> Int Source #

peekElemOff :: Ptr CSChar -> Int -> IO CSChar Source #

pokeElemOff :: Ptr CSChar -> Int -> CSChar -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CSChar Source #

pokeByteOff :: Ptr b -> Int -> CSChar -> IO () Source #

peek :: Ptr CSChar -> IO CSChar Source #

poke :: Ptr CSChar -> CSChar -> IO () Source #

Storable CSUSeconds |

Instance details

Defined in Foreign.C.Types

Methods

sizeOf :: CSUSeconds -> Int Source #

alignment :: CSUSeconds -> Int Source #

peekElemOff :: Ptr CSUSeconds -> Int -> IO CSUSeconds Source #

pokeElemOff :: Ptr CSUSeconds -> Int -> CSUSeconds -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CSUSeconds Source #

pokeByteOff :: Ptr b -> Int -> CSUSeconds -> IO () Source #

peek :: Ptr CSUSeconds -> IO CSUSeconds Source #

poke :: Ptr CSUSeconds -> CSUSeconds -> IO () Source #

Storable CShort |

Instance details

Defined in Foreign.C.Types

Methods

sizeOf :: CShort -> Int Source #

alignment :: CShort -> Int Source #

peekElemOff :: Ptr CShort -> Int -> IO CShort Source #

pokeElemOff :: Ptr CShort -> Int -> CShort -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CShort Source #

pokeByteOff :: Ptr b -> Int -> CShort -> IO () Source #

peek :: Ptr CShort -> IO CShort Source #

poke :: Ptr CShort -> CShort -> IO () Source #

Storable CSigAtomic |

Instance details

Defined in Foreign.C.Types

Methods

sizeOf :: CSigAtomic -> Int Source #

alignment :: CSigAtomic -> Int Source #

peekElemOff :: Ptr CSigAtomic -> Int -> IO CSigAtomic Source #

pokeElemOff :: Ptr CSigAtomic -> Int -> CSigAtomic -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CSigAtomic Source #

pokeByteOff :: Ptr b -> Int -> CSigAtomic -> IO () Source #

peek :: Ptr CSigAtomic -> IO CSigAtomic Source #

poke :: Ptr CSigAtomic -> CSigAtomic -> IO () Source #

Storable CSize |

Instance details

Defined in Foreign.C.Types

Methods

sizeOf :: CSize -> Int Source #

alignment :: CSize -> Int Source #

peekElemOff :: Ptr CSize -> Int -> IO CSize Source #

pokeElemOff :: Ptr CSize -> Int -> CSize -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CSize Source #

pokeByteOff :: Ptr b -> Int -> CSize -> IO () Source #

peek :: Ptr CSize -> IO CSize Source #

poke :: Ptr CSize -> CSize -> IO () Source #

Storable CTime |

Instance details

Defined in Foreign.C.Types

Methods

sizeOf :: CTime -> Int Source #

alignment :: CTime -> Int Source #

peekElemOff :: Ptr CTime -> Int -> IO CTime Source #

pokeElemOff :: Ptr CTime -> Int -> CTime -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CTime Source #

pokeByteOff :: Ptr b -> Int -> CTime -> IO () Source #

peek :: Ptr CTime -> IO CTime Source #

poke :: Ptr CTime -> CTime -> IO () Source #

Storable CUChar |

Instance details

Defined in Foreign.C.Types

Methods

sizeOf :: CUChar -> Int Source #

alignment :: CUChar -> Int Source #

peekElemOff :: Ptr CUChar -> Int -> IO CUChar Source #

pokeElemOff :: Ptr CUChar -> Int -> CUChar -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CUChar Source #

pokeByteOff :: Ptr b -> Int -> CUChar -> IO () Source #

peek :: Ptr CUChar -> IO CUChar Source #

poke :: Ptr CUChar -> CUChar -> IO () Source #

Storable CUInt |

Instance details

Defined in Foreign.C.Types

Methods

sizeOf :: CUInt -> Int Source #

alignment :: CUInt -> Int Source #

peekElemOff :: Ptr CUInt -> Int -> IO CUInt Source #

pokeElemOff :: Ptr CUInt -> Int -> CUInt -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CUInt Source #

pokeByteOff :: Ptr b -> Int -> CUInt -> IO () Source #

peek :: Ptr CUInt -> IO CUInt Source #

poke :: Ptr CUInt -> CUInt -> IO () Source #

Storable CUIntMax |

Instance details

Defined in Foreign.C.Types

Methods

sizeOf :: CUIntMax -> Int Source #

alignment :: CUIntMax -> Int Source #

peekElemOff :: Ptr CUIntMax -> Int -> IO CUIntMax Source #

pokeElemOff :: Ptr CUIntMax -> Int -> CUIntMax -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CUIntMax Source #

pokeByteOff :: Ptr b -> Int -> CUIntMax -> IO () Source #

peek :: Ptr CUIntMax -> IO CUIntMax Source #

poke :: Ptr CUIntMax -> CUIntMax -> IO () Source #

Storable CUIntPtr |

Instance details

Defined in Foreign.C.Types

Methods

sizeOf :: CUIntPtr -> Int Source #

alignment :: CUIntPtr -> Int Source #

peekElemOff :: Ptr CUIntPtr -> Int -> IO CUIntPtr Source #

pokeElemOff :: Ptr CUIntPtr -> Int -> CUIntPtr -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CUIntPtr Source #

pokeByteOff :: Ptr b -> Int -> CUIntPtr -> IO () Source #

peek :: Ptr CUIntPtr -> IO CUIntPtr Source #

poke :: Ptr CUIntPtr -> CUIntPtr -> IO () Source #

Storable CULLong |

Instance details

Defined in Foreign.C.Types

Methods

sizeOf :: CULLong -> Int Source #

alignment :: CULLong -> Int Source #

peekElemOff :: Ptr CULLong -> Int -> IO CULLong Source #

pokeElemOff :: Ptr CULLong -> Int -> CULLong -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CULLong Source #

pokeByteOff :: Ptr b -> Int -> CULLong -> IO () Source #

peek :: Ptr CULLong -> IO CULLong Source #

poke :: Ptr CULLong -> CULLong -> IO () Source #

Storable CULong |

Instance details

Defined in Foreign.C.Types

Methods

sizeOf :: CULong -> Int Source #

alignment :: CULong -> Int Source #

peekElemOff :: Ptr CULong -> Int -> IO CULong Source #

pokeElemOff :: Ptr CULong -> Int -> CULong -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CULong Source #

pokeByteOff :: Ptr b -> Int -> CULong -> IO () Source #

peek :: Ptr CULong -> IO CULong Source #

poke :: Ptr CULong -> CULong -> IO () Source #

Storable CUSeconds |

Instance details

Defined in Foreign.C.Types

Methods

sizeOf :: CUSeconds -> Int Source #

alignment :: CUSeconds -> Int Source #

peekElemOff :: Ptr CUSeconds -> Int -> IO CUSeconds Source #

pokeElemOff :: Ptr CUSeconds -> Int -> CUSeconds -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CUSeconds Source #

pokeByteOff :: Ptr b -> Int -> CUSeconds -> IO () Source #

peek :: Ptr CUSeconds -> IO CUSeconds Source #

poke :: Ptr CUSeconds -> CUSeconds -> IO () Source #

Storable CUShort |

Instance details

Defined in Foreign.C.Types

Methods

sizeOf :: CUShort -> Int Source #

alignment :: CUShort -> Int Source #

peekElemOff :: Ptr CUShort -> Int -> IO CUShort Source #

pokeElemOff :: Ptr CUShort -> Int -> CUShort -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CUShort Source #

pokeByteOff :: Ptr b -> Int -> CUShort -> IO () Source #

peek :: Ptr CUShort -> IO CUShort Source #

poke :: Ptr CUShort -> CUShort -> IO () Source #

Storable CWchar |

Instance details

Defined in Foreign.C.Types

Methods

sizeOf :: CWchar -> Int Source #

alignment :: CWchar -> Int Source #

peekElemOff :: Ptr CWchar -> Int -> IO CWchar Source #

pokeElemOff :: Ptr CWchar -> Int -> CWchar -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CWchar Source #

pokeByteOff :: Ptr b -> Int -> CWchar -> IO () Source #

peek :: Ptr CWchar -> IO CWchar Source #

poke :: Ptr CWchar -> CWchar -> IO () Source #

Storable IntPtr |

Instance details

Defined in Foreign.Ptr

Methods

sizeOf :: IntPtr -> Int Source #

alignment :: IntPtr -> Int Source #

peekElemOff :: Ptr IntPtr -> Int -> IO IntPtr Source #

pokeElemOff :: Ptr IntPtr -> Int -> IntPtr -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO IntPtr Source #

pokeByteOff :: Ptr b -> Int -> IntPtr -> IO () Source #

peek :: Ptr IntPtr -> IO IntPtr Source #

poke :: Ptr IntPtr -> IntPtr -> IO () Source #

Storable WordPtr |

Instance details

Defined in Foreign.Ptr

Methods

sizeOf :: WordPtr -> Int Source #

alignment :: WordPtr -> Int Source #

peekElemOff :: Ptr WordPtr -> Int -> IO WordPtr Source #

pokeElemOff :: Ptr WordPtr -> Int -> WordPtr -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO WordPtr Source #

pokeByteOff :: Ptr b -> Int -> WordPtr -> IO () Source #

peek :: Ptr WordPtr -> IO WordPtr Source #

poke :: Ptr WordPtr -> WordPtr -> IO () Source #

Storable Fingerprint | Since: base-4.4.0.0

Instance details

Defined in Foreign.Storable

Methods

sizeOf :: Fingerprint -> Int Source #

alignment :: Fingerprint -> Int Source #

peekElemOff :: Ptr Fingerprint -> Int -> IO Fingerprint Source #

pokeElemOff :: Ptr Fingerprint -> Int -> Fingerprint -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Fingerprint Source #

pokeByteOff :: Ptr b -> Int -> Fingerprint -> IO () Source #

peek :: Ptr Fingerprint -> IO Fingerprint Source #

poke :: Ptr Fingerprint -> Fingerprint -> IO () Source #

Storable Int16 | Since: base-2.1

Instance details

Defined in Foreign.Storable

Methods

sizeOf :: Int16 -> Int Source #

alignment :: Int16 -> Int Source #

peekElemOff :: Ptr Int16 -> Int -> IO Int16 Source #

pokeElemOff :: Ptr Int16 -> Int -> Int16 -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Int16 Source #

pokeByteOff :: Ptr b -> Int -> Int16 -> IO () Source #

peek :: Ptr Int16 -> IO Int16 Source #

poke :: Ptr Int16 -> Int16 -> IO () Source #

Storable Int32 | Since: base-2.1

Instance details

Defined in Foreign.Storable

Methods

sizeOf :: Int32 -> Int Source #

alignment :: Int32 -> Int Source #

peekElemOff :: Ptr Int32 -> Int -> IO Int32 Source #

pokeElemOff :: Ptr Int32 -> Int -> Int32 -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Int32 Source #

pokeByteOff :: Ptr b -> Int -> Int32 -> IO () Source #

peek :: Ptr Int32 -> IO Int32 Source #

poke :: Ptr Int32 -> Int32 -> IO () Source #

Storable Int64 | Since: base-2.1

Instance details

Defined in Foreign.Storable

Methods

sizeOf :: Int64 -> Int Source #

alignment :: Int64 -> Int Source #

peekElemOff :: Ptr Int64 -> Int -> IO Int64 Source #

pokeElemOff :: Ptr Int64 -> Int -> Int64 -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Int64 Source #

pokeByteOff :: Ptr b -> Int -> Int64 -> IO () Source #

peek :: Ptr Int64 -> IO Int64 Source #

poke :: Ptr Int64 -> Int64 -> IO () Source #

Storable Int8 | Since: base-2.1

Instance details

Defined in Foreign.Storable

Methods

sizeOf :: Int8 -> Int Source #

alignment :: Int8 -> Int Source #

peekElemOff :: Ptr Int8 -> Int -> IO Int8 Source #

pokeElemOff :: Ptr Int8 -> Int -> Int8 -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Int8 Source #

pokeByteOff :: Ptr b -> Int -> Int8 -> IO () Source #

peek :: Ptr Int8 -> IO Int8 Source #

poke :: Ptr Int8 -> Int8 -> IO () Source #

Storable IoSubSystem | Since: base-4.9.0.0

Instance details

Defined in GHC.RTS.Flags

Methods

sizeOf :: IoSubSystem -> Int Source #

alignment :: IoSubSystem -> Int Source #

peekElemOff :: Ptr IoSubSystem -> Int -> IO IoSubSystem Source #

pokeElemOff :: Ptr IoSubSystem -> Int -> IoSubSystem -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO IoSubSystem Source #

pokeByteOff :: Ptr b -> Int -> IoSubSystem -> IO () Source #

peek :: Ptr IoSubSystem -> IO IoSubSystem Source #

poke :: Ptr IoSubSystem -> IoSubSystem -> IO () Source #

Storable Word16 | Since: base-2.1

Instance details

Defined in Foreign.Storable

Methods

sizeOf :: Word16 -> Int Source #

alignment :: Word16 -> Int Source #

peekElemOff :: Ptr Word16 -> Int -> IO Word16 Source #

pokeElemOff :: Ptr Word16 -> Int -> Word16 -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Word16 Source #

pokeByteOff :: Ptr b -> Int -> Word16 -> IO () Source #

peek :: Ptr Word16 -> IO Word16 Source #

poke :: Ptr Word16 -> Word16 -> IO () Source #

Storable Word32 | Since: base-2.1

Instance details

Defined in Foreign.Storable

Methods

sizeOf :: Word32 -> Int Source #

alignment :: Word32 -> Int Source #

peekElemOff :: Ptr Word32 -> Int -> IO Word32 Source #

pokeElemOff :: Ptr Word32 -> Int -> Word32 -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Word32 Source #

pokeByteOff :: Ptr b -> Int -> Word32 -> IO () Source #

peek :: Ptr Word32 -> IO Word32 Source #

poke :: Ptr Word32 -> Word32 -> IO () Source #

Storable Word64 | Since: base-2.1

Instance details

Defined in Foreign.Storable

Methods

sizeOf :: Word64 -> Int Source #

alignment :: Word64 -> Int Source #

peekElemOff :: Ptr Word64 -> Int -> IO Word64 Source #

pokeElemOff :: Ptr Word64 -> Int -> Word64 -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Word64 Source #

pokeByteOff :: Ptr b -> Int -> Word64 -> IO () Source #

peek :: Ptr Word64 -> IO Word64 Source #

poke :: Ptr Word64 -> Word64 -> IO () Source #

Storable Word8 | Since: base-2.1

Instance details

Defined in Foreign.Storable

Methods

sizeOf :: Word8 -> Int Source #

alignment :: Word8 -> Int Source #

peekElemOff :: Ptr Word8 -> Int -> IO Word8 Source #

pokeElemOff :: Ptr Word8 -> Int -> Word8 -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Word8 Source #

pokeByteOff :: Ptr b -> Int -> Word8 -> IO () Source #

peek :: Ptr Word8 -> IO Word8 Source #

poke :: Ptr Word8 -> Word8 -> IO () Source #

Storable CBlkCnt |

Instance details

Defined in System.Posix.Types

Methods

sizeOf :: CBlkCnt -> Int Source #

alignment :: CBlkCnt -> Int Source #

peekElemOff :: Ptr CBlkCnt -> Int -> IO CBlkCnt Source #

pokeElemOff :: Ptr CBlkCnt -> Int -> CBlkCnt -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CBlkCnt Source #

pokeByteOff :: Ptr b -> Int -> CBlkCnt -> IO () Source #

peek :: Ptr CBlkCnt -> IO CBlkCnt Source #

poke :: Ptr CBlkCnt -> CBlkCnt -> IO () Source #

Storable CBlkSize |

Instance details

Defined in System.Posix.Types

Methods

sizeOf :: CBlkSize -> Int Source #

alignment :: CBlkSize -> Int Source #

peekElemOff :: Ptr CBlkSize -> Int -> IO CBlkSize Source #

pokeElemOff :: Ptr CBlkSize -> Int -> CBlkSize -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CBlkSize Source #

pokeByteOff :: Ptr b -> Int -> CBlkSize -> IO () Source #

peek :: Ptr CBlkSize -> IO CBlkSize Source #

poke :: Ptr CBlkSize -> CBlkSize -> IO () Source #

Storable CCc |
Instance details Defined in System.Posix.Types Methods sizeOf :: CCc -> Int Source # alignment :: CCc -> Int Source # peekElemOff :: Ptr CCc -> Int -> IO CCc Source # pokeElemOff :: Ptr CCc -> Int -> CCc -> IO () Source # peekByteOff :: Ptr b -> Int -> IO CCc Source # pokeByteOff :: Ptr b -> Int -> CCc -> IO () Source # peek :: Ptr CCc -> IO CCc Source # poke :: Ptr CCc -> CCc -> IO () Source #
Storable CClockId |

Instance details

Defined in System.Posix.Types

Methods

sizeOf :: CClockId -> Int Source #

alignment :: CClockId -> Int Source #

peekElemOff :: Ptr CClockId -> Int -> IO CClockId Source #

pokeElemOff :: Ptr CClockId -> Int -> CClockId -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CClockId Source #

pokeByteOff :: Ptr b -> Int -> CClockId -> IO () Source #

peek :: Ptr CClockId -> IO CClockId Source #

poke :: Ptr CClockId -> CClockId -> IO () Source #

Storable CDev |

Instance details

Defined in System.Posix.Types

Methods

sizeOf :: CDev -> Int Source #

alignment :: CDev -> Int Source #

peekElemOff :: Ptr CDev -> Int -> IO CDev Source #

pokeElemOff :: Ptr CDev -> Int -> CDev -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CDev Source #

pokeByteOff :: Ptr b -> Int -> CDev -> IO () Source #

peek :: Ptr CDev -> IO CDev Source #

poke :: Ptr CDev -> CDev -> IO () Source #

Storable CFsBlkCnt |

Instance details

Defined in System.Posix.Types

Methods

sizeOf :: CFsBlkCnt -> Int Source #

alignment :: CFsBlkCnt -> Int Source #

peekElemOff :: Ptr CFsBlkCnt -> Int -> IO CFsBlkCnt Source #

pokeElemOff :: Ptr CFsBlkCnt -> Int -> CFsBlkCnt -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CFsBlkCnt Source #

pokeByteOff :: Ptr b -> Int -> CFsBlkCnt -> IO () Source #

peek :: Ptr CFsBlkCnt -> IO CFsBlkCnt Source #

poke :: Ptr CFsBlkCnt -> CFsBlkCnt -> IO () Source #

Storable CFsFilCnt |

Instance details

Defined in System.Posix.Types

Methods

sizeOf :: CFsFilCnt -> Int Source #

alignment :: CFsFilCnt -> Int Source #

peekElemOff :: Ptr CFsFilCnt -> Int -> IO CFsFilCnt Source #

pokeElemOff :: Ptr CFsFilCnt -> Int -> CFsFilCnt -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CFsFilCnt Source #

pokeByteOff :: Ptr b -> Int -> CFsFilCnt -> IO () Source #

peek :: Ptr CFsFilCnt -> IO CFsFilCnt Source #

poke :: Ptr CFsFilCnt -> CFsFilCnt -> IO () Source #

Storable CGid |

Instance details

Defined in System.Posix.Types

Methods

sizeOf :: CGid -> Int Source #

alignment :: CGid -> Int Source #

peekElemOff :: Ptr CGid -> Int -> IO CGid Source #

pokeElemOff :: Ptr CGid -> Int -> CGid -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CGid Source #

pokeByteOff :: Ptr b -> Int -> CGid -> IO () Source #

peek :: Ptr CGid -> IO CGid Source #

poke :: Ptr CGid -> CGid -> IO () Source #

Storable CId |
Instance details Defined in System.Posix.Types Methods sizeOf :: CId -> Int Source # alignment :: CId -> Int Source # peekElemOff :: Ptr CId -> Int -> IO CId Source # pokeElemOff :: Ptr CId -> Int -> CId -> IO () Source # peekByteOff :: Ptr b -> Int -> IO CId Source # pokeByteOff :: Ptr b -> Int -> CId -> IO () Source # peek :: Ptr CId -> IO CId Source # poke :: Ptr CId -> CId -> IO () Source #
Storable CIno |

Instance details

Defined in System.Posix.Types

Methods

sizeOf :: CIno -> Int Source #

alignment :: CIno -> Int Source #

peekElemOff :: Ptr CIno -> Int -> IO CIno Source #

pokeElemOff :: Ptr CIno -> Int -> CIno -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CIno Source #

pokeByteOff :: Ptr b -> Int -> CIno -> IO () Source #

peek :: Ptr CIno -> IO CIno Source #

poke :: Ptr CIno -> CIno -> IO () Source #

Storable CKey |

Instance details

Defined in System.Posix.Types

Methods

sizeOf :: CKey -> Int Source #

alignment :: CKey -> Int Source #

peekElemOff :: Ptr CKey -> Int -> IO CKey Source #

pokeElemOff :: Ptr CKey -> Int -> CKey -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CKey Source #

pokeByteOff :: Ptr b -> Int -> CKey -> IO () Source #

peek :: Ptr CKey -> IO CKey Source #

poke :: Ptr CKey -> CKey -> IO () Source #

Storable CMode |

Instance details

Defined in System.Posix.Types

Methods

sizeOf :: CMode -> Int Source #

alignment :: CMode -> Int Source #

peekElemOff :: Ptr CMode -> Int -> IO CMode Source #

pokeElemOff :: Ptr CMode -> Int -> CMode -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CMode Source #

pokeByteOff :: Ptr b -> Int -> CMode -> IO () Source #

peek :: Ptr CMode -> IO CMode Source #

poke :: Ptr CMode -> CMode -> IO () Source #

Storable CNfds |

Instance details

Defined in System.Posix.Types

Methods

sizeOf :: CNfds -> Int Source #

alignment :: CNfds -> Int Source #

peekElemOff :: Ptr CNfds -> Int -> IO CNfds Source #

pokeElemOff :: Ptr CNfds -> Int -> CNfds -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CNfds Source #

pokeByteOff :: Ptr b -> Int -> CNfds -> IO () Source #

peek :: Ptr CNfds -> IO CNfds Source #

poke :: Ptr CNfds -> CNfds -> IO () Source #

Storable CNlink |

Instance details

Defined in System.Posix.Types

Methods

sizeOf :: CNlink -> Int Source #

alignment :: CNlink -> Int Source #

peekElemOff :: Ptr CNlink -> Int -> IO CNlink Source #

pokeElemOff :: Ptr CNlink -> Int -> CNlink -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CNlink Source #

pokeByteOff :: Ptr b -> Int -> CNlink -> IO () Source #

peek :: Ptr CNlink -> IO CNlink Source #

poke :: Ptr CNlink -> CNlink -> IO () Source #

Storable COff |

Instance details

Defined in System.Posix.Types

Methods

sizeOf :: COff -> Int Source #

alignment :: COff -> Int Source #

peekElemOff :: Ptr COff -> Int -> IO COff Source #

pokeElemOff :: Ptr COff -> Int -> COff -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO COff Source #

pokeByteOff :: Ptr b -> Int -> COff -> IO () Source #

peek :: Ptr COff -> IO COff Source #

poke :: Ptr COff -> COff -> IO () Source #

Storable CPid |

Instance details

Defined in System.Posix.Types

Methods

sizeOf :: CPid -> Int Source #

alignment :: CPid -> Int Source #

peekElemOff :: Ptr CPid -> Int -> IO CPid Source #

pokeElemOff :: Ptr CPid -> Int -> CPid -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CPid Source #

pokeByteOff :: Ptr b -> Int -> CPid -> IO () Source #

peek :: Ptr CPid -> IO CPid Source #

poke :: Ptr CPid -> CPid -> IO () Source #

Storable CRLim |

Instance details

Defined in System.Posix.Types

Methods

sizeOf :: CRLim -> Int Source #

alignment :: CRLim -> Int Source #

peekElemOff :: Ptr CRLim -> Int -> IO CRLim Source #

pokeElemOff :: Ptr CRLim -> Int -> CRLim -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CRLim Source #

pokeByteOff :: Ptr b -> Int -> CRLim -> IO () Source #

peek :: Ptr CRLim -> IO CRLim Source #

poke :: Ptr CRLim -> CRLim -> IO () Source #

Storable CSocklen |

Instance details

Defined in System.Posix.Types

Methods

sizeOf :: CSocklen -> Int Source #

alignment :: CSocklen -> Int Source #

peekElemOff :: Ptr CSocklen -> Int -> IO CSocklen Source #

pokeElemOff :: Ptr CSocklen -> Int -> CSocklen -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CSocklen Source #

pokeByteOff :: Ptr b -> Int -> CSocklen -> IO () Source #

peek :: Ptr CSocklen -> IO CSocklen Source #

poke :: Ptr CSocklen -> CSocklen -> IO () Source #

Storable CSpeed |

Instance details

Defined in System.Posix.Types

Methods

sizeOf :: CSpeed -> Int Source #

alignment :: CSpeed -> Int Source #

peekElemOff :: Ptr CSpeed -> Int -> IO CSpeed Source #

pokeElemOff :: Ptr CSpeed -> Int -> CSpeed -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CSpeed Source #

pokeByteOff :: Ptr b -> Int -> CSpeed -> IO () Source #

peek :: Ptr CSpeed -> IO CSpeed Source #

poke :: Ptr CSpeed -> CSpeed -> IO () Source #

Storable CSsize |

Instance details

Defined in System.Posix.Types

Methods

sizeOf :: CSsize -> Int Source #

alignment :: CSsize -> Int Source #

peekElemOff :: Ptr CSsize -> Int -> IO CSsize Source #

pokeElemOff :: Ptr CSsize -> Int -> CSsize -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CSsize Source #

pokeByteOff :: Ptr b -> Int -> CSsize -> IO () Source #

peek :: Ptr CSsize -> IO CSsize Source #

poke :: Ptr CSsize -> CSsize -> IO () Source #

Storable CTcflag |

Instance details

Defined in System.Posix.Types

Methods

sizeOf :: CTcflag -> Int Source #

alignment :: CTcflag -> Int Source #

peekElemOff :: Ptr CTcflag -> Int -> IO CTcflag Source #

pokeElemOff :: Ptr CTcflag -> Int -> CTcflag -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CTcflag Source #

pokeByteOff :: Ptr b -> Int -> CTcflag -> IO () Source #

peek :: Ptr CTcflag -> IO CTcflag Source #

poke :: Ptr CTcflag -> CTcflag -> IO () Source #

Storable CTimer |

Instance details

Defined in System.Posix.Types

Methods

sizeOf :: CTimer -> Int Source #

alignment :: CTimer -> Int Source #

peekElemOff :: Ptr CTimer -> Int -> IO CTimer Source #

pokeElemOff :: Ptr CTimer -> Int -> CTimer -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CTimer Source #

pokeByteOff :: Ptr b -> Int -> CTimer -> IO () Source #

peek :: Ptr CTimer -> IO CTimer Source #

poke :: Ptr CTimer -> CTimer -> IO () Source #

Storable CUid |

Instance details

Defined in System.Posix.Types

Methods

sizeOf :: CUid -> Int Source #

alignment :: CUid -> Int Source #

peekElemOff :: Ptr CUid -> Int -> IO CUid Source #

pokeElemOff :: Ptr CUid -> Int -> CUid -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO CUid Source #

pokeByteOff :: Ptr b -> Int -> CUid -> IO () Source #

peek :: Ptr CUid -> IO CUid Source #

poke :: Ptr CUid -> CUid -> IO () Source #

Storable Fd |
Instance details Defined in System.Posix.Types Methods sizeOf :: Fd -> Int Source # alignment :: Fd -> Int Source # peekElemOff :: Ptr Fd -> Int -> IO Fd Source # pokeElemOff :: Ptr Fd -> Int -> Fd -> IO () Source # peekByteOff :: Ptr b -> Int -> IO Fd Source # pokeByteOff :: Ptr b -> Int -> Fd -> IO () Source # peek :: Ptr Fd -> IO Fd Source # poke :: Ptr Fd -> Fd -> IO () Source #
Storable () | Since: base-4.9.0.0
Instance details Defined in Foreign.Storable Methods sizeOf :: () -> Int Source # alignment :: () -> Int Source # peekElemOff :: Ptr () -> Int -> IO () Source # pokeElemOff :: Ptr () -> Int -> () -> IO () Source # peekByteOff :: Ptr b -> Int -> IO () Source # pokeByteOff :: Ptr b -> Int -> () -> IO () Source # peek :: Ptr () -> IO () Source # poke :: Ptr () -> () -> IO () Source #
Storable Bool | Since: base-2.1

Instance details

Defined in Foreign.Storable

Methods

sizeOf :: Bool -> Int Source #

alignment :: Bool -> Int Source #

peekElemOff :: Ptr Bool -> Int -> IO Bool Source #

pokeElemOff :: Ptr Bool -> Int -> Bool -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Bool Source #

pokeByteOff :: Ptr b -> Int -> Bool -> IO () Source #

peek :: Ptr Bool -> IO Bool Source #

poke :: Ptr Bool -> Bool -> IO () Source #

Storable Char | Since: base-2.1

Instance details

Defined in Foreign.Storable

Methods

sizeOf :: Char -> Int Source #

alignment :: Char -> Int Source #

peekElemOff :: Ptr Char -> Int -> IO Char Source #

pokeElemOff :: Ptr Char -> Int -> Char -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Char Source #

pokeByteOff :: Ptr b -> Int -> Char -> IO () Source #

peek :: Ptr Char -> IO Char Source #

poke :: Ptr Char -> Char -> IO () Source #

Storable Double | Since: base-2.1

Instance details

Defined in Foreign.Storable

Methods

sizeOf :: Double -> Int Source #

alignment :: Double -> Int Source #

peekElemOff :: Ptr Double -> Int -> IO Double Source #

pokeElemOff :: Ptr Double -> Int -> Double -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Double Source #

pokeByteOff :: Ptr b -> Int -> Double -> IO () Source #

peek :: Ptr Double -> IO Double Source #

poke :: Ptr Double -> Double -> IO () Source #

Storable Float | Since: base-2.1

Instance details

Defined in Foreign.Storable

Methods

sizeOf :: Float -> Int Source #

alignment :: Float -> Int Source #

peekElemOff :: Ptr Float -> Int -> IO Float Source #

pokeElemOff :: Ptr Float -> Int -> Float -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Float Source #

pokeByteOff :: Ptr b -> Int -> Float -> IO () Source #

peek :: Ptr Float -> IO Float Source #

poke :: Ptr Float -> Float -> IO () Source #

Storable Int | Since: base-2.1
Instance details Defined in Foreign.Storable Methods sizeOf :: Int -> Int Source # alignment :: Int -> Int Source # peekElemOff :: Ptr Int -> Int -> IO Int Source # pokeElemOff :: Ptr Int -> Int -> Int -> IO () Source # peekByteOff :: Ptr b -> Int -> IO Int Source # pokeByteOff :: Ptr b -> Int -> Int -> IO () Source # peek :: Ptr Int -> IO Int Source # poke :: Ptr Int -> Int -> IO () Source #
Storable Word | Since: base-2.1

Instance details

Defined in Foreign.Storable

Methods

sizeOf :: Word -> Int Source #

alignment :: Word -> Int Source #

peekElemOff :: Ptr Word -> Int -> IO Word Source #

pokeElemOff :: Ptr Word -> Int -> Word -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Word Source #

pokeByteOff :: Ptr b -> Int -> Word -> IO () Source #

peek :: Ptr Word -> IO Word Source #

poke :: Ptr Word -> Word -> IO () Source #

Storable a => Storable (Complex a) | Since: base-4.8.0.0

Instance details

Defined in Data.Complex

Methods

sizeOf :: Complex a -> Int Source #

alignment :: Complex a -> Int Source #

peekElemOff :: Ptr (Complex a) -> Int -> IO (Complex a) Source #

pokeElemOff :: Ptr (Complex a) -> Int -> Complex a -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO (Complex a) Source #

pokeByteOff :: Ptr b -> Int -> Complex a -> IO () Source #

peek :: Ptr (Complex a) -> IO (Complex a) Source #

poke :: Ptr (Complex a) -> Complex a -> IO () Source #

Storable a => Storable (Identity a) | Since: base-4.9.0.0

Instance details

Defined in Data.Functor.Identity

Methods

sizeOf :: Identity a -> Int Source #

alignment :: Identity a -> Int Source #

peekElemOff :: Ptr (Identity a) -> Int -> IO (Identity a) Source #

pokeElemOff :: Ptr (Identity a) -> Int -> Identity a -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO (Identity a) Source #

pokeByteOff :: Ptr b -> Int -> Identity a -> IO () Source #

peek :: Ptr (Identity a) -> IO (Identity a) Source #

poke :: Ptr (Identity a) -> Identity a -> IO () Source #

Storable a => Storable (Down a) | Since: base-4.14.0.0

Instance details

Defined in Data.Ord

Methods

sizeOf :: Down a -> Int Source #

alignment :: Down a -> Int Source #

peekElemOff :: Ptr (Down a) -> Int -> IO (Down a) Source #

pokeElemOff :: Ptr (Down a) -> Int -> Down a -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO (Down a) Source #

pokeByteOff :: Ptr b -> Int -> Down a -> IO () Source #

peek :: Ptr (Down a) -> IO (Down a) Source #

poke :: Ptr (Down a) -> Down a -> IO () Source #

Storable (ConstPtr a) |

Instance details

Defined in Foreign.Storable

Methods

sizeOf :: ConstPtr a -> Int Source #

alignment :: ConstPtr a -> Int Source #

peekElemOff :: Ptr (ConstPtr a) -> Int -> IO (ConstPtr a) Source #

pokeElemOff :: Ptr (ConstPtr a) -> Int -> ConstPtr a -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO (ConstPtr a) Source #

pokeByteOff :: Ptr b -> Int -> ConstPtr a -> IO () Source #

peek :: Ptr (ConstPtr a) -> IO (ConstPtr a) Source #

poke :: Ptr (ConstPtr a) -> ConstPtr a -> IO () Source #

Storable (FunPtr a) | Since: base-2.1

Instance details

Defined in Foreign.Storable

Methods

sizeOf :: FunPtr a -> Int Source #

alignment :: FunPtr a -> Int Source #

peekElemOff :: Ptr (FunPtr a) -> Int -> IO (FunPtr a) Source #

pokeElemOff :: Ptr (FunPtr a) -> Int -> FunPtr a -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO (FunPtr a) Source #

pokeByteOff :: Ptr b -> Int -> FunPtr a -> IO () Source #

peek :: Ptr (FunPtr a) -> IO (FunPtr a) Source #

poke :: Ptr (FunPtr a) -> FunPtr a -> IO () Source #

Storable (Ptr a) | Since: base-2.1

Instance details

Defined in Foreign.Storable

Methods

sizeOf :: Ptr a -> Int Source #

alignment :: Ptr a -> Int Source #

peekElemOff :: Ptr (Ptr a) -> Int -> IO (Ptr a) Source #

pokeElemOff :: Ptr (Ptr a) -> Int -> Ptr a -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO (Ptr a) Source #

pokeByteOff :: Ptr b -> Int -> Ptr a -> IO () Source #

peek :: Ptr (Ptr a) -> IO (Ptr a) Source #

poke :: Ptr (Ptr a) -> Ptr a -> IO () Source #

(Storable a, Integral a) => Storable (Ratio a) | Since: base-4.8.0.0

Instance details

Defined in Foreign.Storable

Methods

sizeOf :: Ratio a -> Int Source #

alignment :: Ratio a -> Int Source #

peekElemOff :: Ptr (Ratio a) -> Int -> IO (Ratio a) Source #

pokeElemOff :: Ptr (Ratio a) -> Int -> Ratio a -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO (Ratio a) Source #

pokeByteOff :: Ptr b -> Int -> Ratio a -> IO () Source #

peek :: Ptr (Ratio a) -> IO (Ratio a) Source #

poke :: Ptr (Ratio a) -> Ratio a -> IO () Source #

Storable (StablePtr a) | Since: base-2.1

Instance details

Defined in Foreign.Storable

Methods

sizeOf :: StablePtr a -> Int Source #

alignment :: StablePtr a -> Int Source #

peekElemOff :: Ptr (StablePtr a) -> Int -> IO (StablePtr a) Source #

pokeElemOff :: Ptr (StablePtr a) -> Int -> StablePtr a -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO (StablePtr a) Source #

pokeByteOff :: Ptr b -> Int -> StablePtr a -> IO () Source #

peek :: Ptr (StablePtr a) -> IO (StablePtr a) Source #

poke :: Ptr (StablePtr a) -> StablePtr a -> IO () Source #

Storable a => Storable (Const a b) | Since: base-4.9.0.0

Instance details

Defined in Data.Functor.Const

Methods

sizeOf :: Const a b -> Int Source #

alignment :: Const a b -> Int Source #

peekElemOff :: Ptr (Const a b) -> Int -> IO (Const a b) Source #

pokeElemOff :: Ptr (Const a b) -> Int -> Const a b -> IO () Source #

peekByteOff :: Ptr b0 -> Int -> IO (Const a b) Source #

pokeByteOff :: Ptr b0 -> Int -> Const a b -> IO () Source #

peek :: Ptr (Const a b) -> IO (Const a b) Source #

poke :: Ptr (Const a b) -> Const a b -> IO () Source #

# Accessors

## Length information

length :: Storable a => Vector a -> Int Source #

O(1) Yield the length of the vector.

null :: Storable a => Vector a -> Bool Source #

O(1) Test whether a vector is empty.

## Indexing

(!?) :: Storable a => Vector a -> Int -> Maybe a Source #

O(1) Safe indexing.

## Extracting subvectors

slice Source #

Arguments

:: Storable a |
=> Int | `i` starting index
-> Int | `n` length
-> Vector a |
-> Vector a |

O(1) Yield a slice of the vector without copying it. The vector must contain at least `i+n` elements.

take :: Storable a => Int -> Vector a -> Vector a Source #

O(1) Yield at the first `n` elements without copying. The vector may contain less than `n` elements, in which case it is returned unchanged.

drop :: Storable a => Int -> Vector a -> Vector a Source #

O(1) Yield all but the first `n` elements without copying. The vector may contain less than `n` elements, in which case an empty vector is returned.

splitAt :: Storable a => Int -> Vector a -> (Vector a, Vector a) Source #

O(1) Yield the first `n` elements paired with the remainder, without copying.

Note that ``splitAt` n v` is equivalent to `(`take` n v, `drop` n v)`, but slightly more efficient.

Since: vector-0.7.1

# Construction

## Initialisation

empty :: Storable a => Vector a Source #

O(1) The empty vector.

singleton :: Storable a => a -> Vector a Source #

O(1) A vector with exactly one element.

replicate :: Storable a => Int -> a -> Vector a Source #

O(n) A vector of the given length with the same value in each position.

generate :: Storable a => Int -> (Int -> a) -> Vector a Source #

O(n) Construct a vector of the given length by applying the function to each index.

iterateN :: Storable a => Int -> (a -> a) -> a -> Vector a Source #

O(n) Apply the function \(\max(n - 1, 0)\) times to an initial value, producing a vector of length \(\max(n, 0)\). The 0th element will contain the initial value, which is why there is one less function application than the number of elements in the produced vector.

\( \underbrace{x, f (x), f (f (x)), \ldots}_{\max(0,n)\rm{~elements}} \)

### Examples

Expand

    >>> import qualified Data.Vector.Storable as VS
    >>> VS.iterateN 0 undefined undefined :: VS.Vector Int
    []
    >>> VS.iterateN 26 succ 'a'
    "abcdefghijklmnopqrstuvwxyz"

Since: vector-0.7.1

## Monadic initialisation

replicateM :: (Monad m, Storable a) => Int -> m a -> m (Vector a) Source #

O(n) Execute the monadic action the given number of times and store the results in a vector.

generateM :: (Monad m, Storable a) => Int -> (Int -> m a) -> m (Vector a) Source #

O(n) Construct a vector of the given length by applying the monadic action to each index.

iterateNM :: (Monad m, Storable a) => Int -> (a -> m a) -> a -> m (Vector a) Source #

O(n) Apply the monadic function \(\max(n - 1, 0)\) times to an initial value, producing a vector of length \(\max(n, 0)\). The 0th element will contain the initial value, which is why there is one less function application than the number of elements in the produced vector.

For a non-monadic version, see `iterateN`.

Since: vector-0.12.0.0

create :: Storable a => (forall s. ST s (MVector s a)) -> Vector a Source #

Execute the monadic action and freeze the resulting vector.

    create (do { v <- new 2; write v 0 'a'; write v 1 'b'; return v }) = <a,b>

createT :: (Traversable f, Storable a) => (forall s. ST s (f (MVector s a))) -> f (Vector a) Source #

Execute the monadic action and freeze the resulting vectors.

## Unfolding

unfoldr :: Storable a => (b -> Maybe (a, b)) -> b -> Vector a Source #

O(n) Construct a vector by repeatedly applying the generator function to a seed. The generator function yields `Just` the next element and the new seed or `Nothing` if there are no more elements.

    unfoldr (\n -> if n == 0 then Nothing else Just (n,n-1)) 10
     = <10,9,8,7,6,5,4,3,2,1>

unfoldrN :: Storable a => Int -> (b -> Maybe (a, b)) -> b -> Vector a Source #

O(n) Construct a vector with at most `n` elements by repeatedly applying the generator function to a seed. The generator function yields `Just` the next element and the new seed or `Nothing` if there are no more elements.

    unfoldrN 3 (\n -> Just (n,n-1)) 10 = <10,9,8>

unfoldrM :: (Monad m, Storable a) => (b -> m (Maybe (a, b))) -> b -> m (Vector a) Source #

O(n) Construct a vector by repeatedly applying the monadic generator function to a seed. The generator function yields `Just` the next element and the new seed or `Nothing` if there are no more elements.

unfoldrNM :: (Monad m, Storable a) => Int -> (b -> m (Maybe (a, b))) -> b -> m (Vector a) Source #

O(n) Construct a vector by repeatedly applying the monadic generator function to a seed. The generator function yields `Just` the next element and the new seed or `Nothing` if there are no more elements.

constructN :: Storable a => Int -> (Vector a -> a) -> Vector a Source #

O(n) Construct a vector with `n` elements by repeatedly applying the generator function to the already constructed part of the vector.

    constructN 3 f = let a = f <> ; b = f <a> ; c = f <a,b> in <a,b,c>

constructrN :: Storable a => Int -> (Vector a -> a) -> Vector a Source #

O(n) Construct a vector with `n` elements from right to left by repeatedly applying the generator function to the already constructed part of the vector.

    constructrN 3 f = let a = f <> ; b = f<a> ; c = f <b,a> in <c,b,a>

## Enumeration

enumFromN :: (Storable a, Num a) => a -> Int -> Vector a Source #

O(n) Yield a vector of the given length, containing the values `x`, `x+1` etc. This operation is usually more efficient than `enumFromTo`.

    enumFromN 5 3 = <5,6,7>

enumFromStepN :: (Storable a, Num a) => a -> a -> Int -> Vector a Source #

O(n) Yield a vector of the given length, containing the values `x`, `x+y`, `x+y+y` etc. This operations is usually more efficient than `enumFromThenTo`.

    enumFromStepN 1 2 5 = <1,3,5,7,9>

enumFromTo :: (Storable a, Enum a) => a -> a -> Vector a Source #

O(n) Enumerate values from `x` to `y`.

WARNING: This operation can be very inefficient. If possible, use `enumFromN` instead.

enumFromThenTo :: (Storable a, Enum a) => a -> a -> a -> Vector a Source #

O(n) Enumerate values from `x` to `y` with a specific step `z`.

WARNING: This operation can be very inefficient. If possible, use `enumFromStepN` instead.

## Concatenation

cons :: Storable a => a -> Vector a -> Vector a Source #

O(n) Prepend an element.

snoc :: Storable a => Vector a -> a -> Vector a Source #

O(n) Append an element.

(++) :: Storable a => Vector a -> Vector a -> Vector a infixr 5 Source #

O(m+n) Concatenate two vectors.

concat :: Storable a => [Vector a] -> Vector a Source #

O(n) Concatenate all vectors in the list.

## Restricting memory usage

force :: Storable a => Vector a -> Vector a Source #

O(n) Yield the argument, but force it not to retain any extra memory, possibly by copying it.

This is especially useful when dealing with slices. For example:

    force (slice 0 2 <huge vector>)

Here, the slice retains a reference to the huge vector. Forcing it creates a copy of just the elements that belong to the slice and allows the huge vector to be garbage collected.

# Modifying vectors

## Permutations

reverse :: Storable a => Vector a -> Vector a Source #

O(n) Reverse a vector.

## Safe destructive update

modify :: Storable a => (forall s. MVector s a -> ST s ()) -> Vector a -> Vector a Source #

Apply a destructive operation to a vector. The operation may be performed in place if it is safe to do so and will modify a copy of the vector otherwise (see `New` for details).

#### Examples

Expand

    >>> import qualified Data.Vector.Storable as VS
    >>> import qualified Data.Vector.Storable.Mutable as MVS
    >>> VS.modify (\v -> MVS.write v 0 'x') $ VS.replicate 4 'a'
    "xaaa"

# Elementwise operations

## Mapping

map :: (Storable a, Storable b) => (a -> b) -> Vector a -> Vector b Source #

O(n) Map a function over a vector.

imap :: (Storable a, Storable b) => (Int -> a -> b) -> Vector a -> Vector b Source #

O(n) Apply a function to every element of a vector and its index.

concatMap :: (Storable a, Storable b) => (a -> Vector b) -> Vector a -> Vector b Source #

Map a function over a vector and concatenate the results.

## Monadic mapping

mapM :: (Monad m, Storable a, Storable b) => (a -> m b) -> Vector a -> m (Vector b) Source #

O(n) Apply the monadic action to all elements of the vector, yielding a vector of results.

mapM_ :: (Monad m, Storable a) => (a -> m b) -> Vector a -> m () Source #

O(n) Apply the monadic action to all elements of a vector and ignore the results.

forM :: (Monad m, Storable a, Storable b) => Vector a -> (a -> m b) -> m (Vector b) Source #

O(n) Apply the monadic action to all elements of the vector, yielding a vector of results. Equivalent to `flip `mapM``.

forM_ :: (Monad m, Storable a) => Vector a -> (a -> m b) -> m () Source #

O(n) Apply the monadic action to all elements of a vector and ignore the results. Equivalent to `flip `mapM_``.

## Zipping

zipWith :: (Storable a, Storable b, Storable c) => (a -> b -> c) -> Vector a -> Vector b -> Vector c Source #

O(min(m,n)) Zip two vectors with the given function.

zipWith3 :: (Storable a, Storable b, Storable c, Storable d) => (a -> b -> c -> d) -> Vector a -> Vector b -> Vector c -> Vector d Source #

Zip three vectors with the given function.

zipWith4 :: (Storable a, Storable b, Storable c, Storable d, Storable e) => (a -> b -> c -> d -> e) -> Vector a -> Vector b -> Vector c -> Vector d -> Vector e Source #

zipWith5 :: (Storable a, Storable b, Storable c, Storable d, Storable e, Storable f) => (a -> b -> c -> d -> e -> f) -> Vector a -> Vector b -> Vector c -> Vector d -> Vector e -> Vector f Source #

zipWith6 :: (Storable a, Storable b, Storable c, Storable d, Storable e, Storable f, Storable g) => (a -> b -> c -> d -> e -> f -> g) -> Vector a -> Vector b -> Vector c -> Vector d -> Vector e -> Vector f -> Vector g Source #

izipWith :: (Storable a, Storable b, Storable c) => (Int -> a -> b -> c) -> Vector a -> Vector b -> Vector c Source #

O(min(m,n)) Zip two vectors with a function that also takes the elements' indices.

izipWith3 :: (Storable a, Storable b, Storable c, Storable d) => (Int -> a -> b -> c -> d) -> Vector a -> Vector b -> Vector c -> Vector d Source #

Zip three vectors and their indices with the given function.

izipWith4 :: (Storable a, Storable b, Storable c, Storable d, Storable e) => (Int -> a -> b -> c -> d -> e) -> Vector a -> Vector b -> Vector c -> Vector d -> Vector e Source #

izipWith5 :: (Storable a, Storable b, Storable c, Storable d, Storable e, Storable f) => (Int -> a -> b -> c -> d -> e -> f) -> Vector a -> Vector b -> Vector c -> Vector d -> Vector e -> Vector f Source #

izipWith6 :: (Storable a, Storable b, Storable c, Storable d, Storable e, Storable f, Storable g) => (Int -> a -> b -> c -> d -> e -> f -> g) -> Vector a -> Vector b -> Vector c -> Vector d -> Vector e -> Vector f -> Vector g Source #

## Monadic zipping

zipWithM :: (Monad m, Storable a, Storable b, Storable c) => (a -> b -> m c) -> Vector a -> Vector b -> m (Vector c) Source #

O(min(m,n)) Zip the two vectors with the monadic action and yield a vector of results.

zipWithM_ :: (Monad m, Storable a, Storable b) => (a -> b -> m c) -> Vector a -> Vector b -> m () Source #

O(min(m,n)) Zip the two vectors with the monadic action and ignore the results.

# Working with predicates

## Filtering

filter :: Storable a => (a -> Bool) -> Vector a -> Vector a Source #

O(n) Drop all elements that do not satisfy the predicate.

ifilter :: Storable a => (Int -> a -> Bool) -> Vector a -> Vector a Source #

O(n) Drop all elements that do not satisfy the predicate which is applied to the values and their indices.

uniq :: (Storable a, Eq a) => Vector a -> Vector a Source #

O(n) Drop repeated adjacent elements. The first element in each group is returned.

#### Examples

Expand

    >>> import qualified Data.Vector.Storable as VS
    >>> VS.uniq $ VS.fromList [1,3,3,200,3 :: Int]
    [1,3,200,3]

mapMaybe :: (Storable a, Storable b) => (a -> Maybe b) -> Vector a -> Vector b Source #

O(n) Map the values and collect the `Just` results.

imapMaybe :: (Storable a, Storable b) => (Int -> a -> Maybe b) -> Vector a -> Vector b Source #

O(n) Map the indices/values and collect the `Just` results.

filterM :: (Monad m, Storable a) => (a -> m Bool) -> Vector a -> m (Vector a) Source #

O(n) Drop all elements that do not satisfy the monadic predicate.

takeWhile :: Storable a => (a -> Bool) -> Vector a -> Vector a Source #

O(n) Yield the longest prefix of elements satisfying the predicate. The current implementation is not copy-free, unless the result vector is fused away.

dropWhile :: Storable a => (a -> Bool) -> Vector a -> Vector a Source #

O(n) Drop the longest prefix of elements that satisfy the predicate without copying.

## Partitioning

partition :: Storable a => (a -> Bool) -> Vector a -> (Vector a, Vector a) Source #

O(n) Split the vector in two parts, the first one containing those elements that satisfy the predicate and the second one those that don't. The relative order of the elements is preserved at the cost of a sometimes reduced performance compared to `unstablePartition`.

unstablePartition :: Storable a => (a -> Bool) -> Vector a -> (Vector a, Vector a) Source #

O(n) Split the vector in two parts, the first one containing those elements that satisfy the predicate and the second one those that don't. The order of the elements is not preserved, but the operation is often faster than `partition`.

span :: Storable a => (a -> Bool) -> Vector a -> (Vector a, Vector a) Source #

O(n) Split the vector into the longest prefix of elements that satisfy the predicate and the rest without copying.

break :: Storable a => (a -> Bool) -> Vector a -> (Vector a, Vector a) Source #

O(n) Split the vector into the longest prefix of elements that do not satisfy the predicate and the rest without copying.

## Searching

elem :: (Storable a, Eq a) => a -> Vector a -> Bool infix 4 Source #

O(n) Check if the vector contains an element.

notElem :: (Storable a, Eq a) => a -> Vector a -> Bool infix 4 Source #

O(n) Check if the vector does not contain an element (inverse of `elem`).

find :: Storable a => (a -> Bool) -> Vector a -> Maybe a Source #

O(n) Yield `Just` the first element matching the predicate or `Nothing` if no such element exists.

findIndex :: Storable a => (a -> Bool) -> Vector a -> Maybe Int Source #

O(n) Yield `Just` the index of the first element matching the predicate or `Nothing` if no such element exists.

findIndices :: Storable a => (a -> Bool) -> Vector a -> Vector Int Source #

O(n) Yield the indices of elements satisfying the predicate in ascending order.

elemIndex :: (Storable a, Eq a) => a -> Vector a -> Maybe Int Source #

O(n) Yield `Just` the index of the first occurrence of the given element or `Nothing` if the vector does not contain the element. This is a specialised version of `findIndex`.

elemIndices :: (Storable a, Eq a) => a -> Vector a -> Vector Int Source #

O(n) Yield the indices of all occurrences of the given element in ascending order. This is a specialised version of `findIndices`.

# Folding

foldl :: Storable b => (a -> b -> a) -> a -> Vector b -> a Source #

O(n) Left fold.

foldl' :: Storable b => (a -> b -> a) -> a -> Vector b -> a Source #

O(n) Left fold with strict accumulator.

foldr :: Storable a => (a -> b -> b) -> b -> Vector a -> b Source #

O(n) Right fold.

foldr' :: Storable a => (a -> b -> b) -> b -> Vector a -> b Source #

O(n) Right fold with a strict accumulator.

ifoldl :: Storable b => (a -> Int -> b -> a) -> a -> Vector b -> a Source #

O(n) Left fold using a function applied to each element and its index.

ifoldl' :: Storable b => (a -> Int -> b -> a) -> a -> Vector b -> a Source #

O(n) Left fold with strict accumulator using a function applied to each element and its index.

ifoldr :: Storable a => (Int -> a -> b -> b) -> b -> Vector a -> b Source #

O(n) Right fold using a function applied to each element and its index.

ifoldr' :: Storable a => (Int -> a -> b -> b) -> b -> Vector a -> b Source #

O(n) Right fold with strict accumulator using a function applied to each element and its index.

## Specialised folds

all :: Storable a => (a -> Bool) -> Vector a -> Bool Source #

O(n) Check if all elements satisfy the predicate.

#### Examples

Expand

    >>> import qualified Data.Vector.Storable as VS
    >>> VS.all even $ VS.fromList [2, 4, 12 :: Int]
    True
    >>> VS.all even $ VS.fromList [2, 4, 13 :: Int]
    False
    >>> VS.all even (VS.empty :: VS.Vector Int)
    True

any :: Storable a => (a -> Bool) -> Vector a -> Bool Source #

O(n) Check if any element satisfies the predicate.

#### Examples

Expand

    >>> import qualified Data.Vector.Storable as VS
    >>> VS.any even $ VS.fromList [1, 3, 7 :: Int]
    False
    >>> VS.any even $ VS.fromList [3, 2, 13 :: Int]
    True
    >>> VS.any even (VS.empty :: VS.Vector Int)
    False

and :: Vector Bool -> Bool Source #

O(n) Check if all elements are `True`.

#### Examples

Expand

    >>> import qualified Data.Vector.Storable as VS
    >>> VS.and $ VS.fromList [True, False]
    False
    >>> VS.and VS.empty
    True

or :: Vector Bool -> Bool Source #

O(n) Check if any element is `True`.

#### Examples

Expand

    >>> import qualified Data.Vector.Storable as VS
    >>> VS.or $ VS.fromList [True, False]
    True
    >>> VS.or VS.empty
    False

sum :: (Storable a, Num a) => Vector a -> a Source #

O(n) Compute the sum of the elements.

#### Examples

Expand

    >>> import qualified Data.Vector.Storable as VS
    >>> VS.sum $ VS.fromList [300,20,1 :: Int]
    321
    >>> VS.sum (VS.empty :: VS.Vector Int)
    0

product :: (Storable a, Num a) => Vector a -> a Source #

O(n) Compute the product of the elements.

#### Examples

Expand

    >>> import qualified Data.Vector.Storable as VS
    >>> VS.product $ VS.fromList [1,2,3,4 :: Int]
    24
    >>> VS.product (VS.empty :: VS.Vector Int)
    1

## Monadic folds

foldM :: (Monad m, Storable b) => (a -> b -> m a) -> a -> Vector b -> m a Source #

O(n) Monadic fold.

foldM' :: (Monad m, Storable b) => (a -> b -> m a) -> a -> Vector b -> m a Source #

O(n) Monadic fold with strict accumulator.

foldM_ :: (Monad m, Storable b) => (a -> b -> m a) -> a -> Vector b -> m () Source #

O(n) Monadic fold that discards the result.

foldM'_ :: (Monad m, Storable b) => (a -> b -> m a) -> a -> Vector b -> m () Source #

O(n) Monadic fold with strict accumulator that discards the result.

# Prefix sums (scans)

prescanl :: (Storable a, Storable b) => (a -> b -> a) -> a -> Vector b -> Vector a Source #

O(n) Left-to-right prescan.

    prescanl f z = init . scanl f z

#### Examples

Expand

    >>> import qualified Data.Vector.Storable as VS
    >>> VS.prescanl (+) 0 (VS.fromList [1,2,3,4 :: Int])
    [0,1,3,6]

prescanl' :: (Storable a, Storable b) => (a -> b -> a) -> a -> Vector b -> Vector a Source #

O(n) Left-to-right prescan with strict accumulator.

postscanl :: (Storable a, Storable b) => (a -> b -> a) -> a -> Vector b -> Vector a Source #

O(n) Left-to-right postscan.

    postscanl f z = tail . scanl f z

#### Examples

Expand

    >>> import qualified Data.Vector.Storable as VS
    >>> VS.postscanl (+) 0 (VS.fromList [1,2,3,4 :: Int])
    [1,3,6,10]

postscanl' :: (Storable a, Storable b) => (a -> b -> a) -> a -> Vector b -> Vector a Source #

O(n) Left-to-right postscan with strict accumulator.

scanl :: (Storable a, Storable b) => (a -> b -> a) -> a -> Vector b -> Vector a Source #

O(n) Left-to-right scan.

    scanl f z <x1,...,xn> = <y1,...,y(n+1)>
      where y1 = z
            yi = f y(i-1) x(i-1)

#### Examples

Expand

    >>> import qualified Data.Vector.Storable as VS
    >>> VS.scanl (+) 0 (VS.fromList [1,2,3,4 :: Int])
    [0,1,3,6,10]

scanl' :: (Storable a, Storable b) => (a -> b -> a) -> a -> Vector b -> Vector a Source #

O(n) Left-to-right scan with strict accumulator.

prescanr :: (Storable a, Storable b) => (a -> b -> b) -> b -> Vector a -> Vector b Source #

O(n) Right-to-left prescan.

    prescanr f z = reverse . prescanl (flip f) z . reverse

prescanr' :: (Storable a, Storable b) => (a -> b -> b) -> b -> Vector a -> Vector b Source #

O(n) Right-to-left prescan with strict accumulator.

postscanr :: (Storable a, Storable b) => (a -> b -> b) -> b -> Vector a -> Vector b Source #

O(n) Right-to-left postscan.

postscanr' :: (Storable a, Storable b) => (a -> b -> b) -> b -> Vector a -> Vector b Source #

O(n) Right-to-left postscan with strict accumulator.

scanr :: (Storable a, Storable b) => (a -> b -> b) -> b -> Vector a -> Vector b Source #

O(n) Right-to-left scan.

scanr' :: (Storable a, Storable b) => (a -> b -> b) -> b -> Vector a -> Vector b Source #

O(n) Right-to-left scan with strict accumulator.

# Conversions

## Lists

toList :: Storable a => Vector a -> [a] Source #

O(n) Convert a vector to a list.

fromList :: Storable a => [a] -> Vector a Source #

O(n) Convert a list to a vector.

fromListN :: Storable a => Int -> [a] -> Vector a Source #

O(n) Convert the first `n` elements of a list to a vector. It's expected that the supplied list will be exactly `n` elements long. As an optimization, this function allocates a buffer for `n` elements, which could be used for DoS-attacks by exhausting the memory if an attacker controls that parameter.

    fromListN n xs = fromList (take n xs)

#### Examples

Expand

    >>> import qualified Data.Vector.Storable as VS
    >>> VS.fromListN 3 [1,2,3,4,5 :: Int]
    [1,2,3]
    >>> VS.fromListN 3 [1 :: Int]
    [1]

## Different vector types

convert :: (Vector v a, Vector w a) => v a -> w a Source #

O(n) Convert between different vector types.

## Mutable vectors

freeze :: (Storable a, PrimMonad m) => MVector (PrimState m) a -> m (Vector a) Source #

O(n) Yield an immutable copy of the mutable vector.

thaw :: (Storable a, PrimMonad m) => Vector a -> m (MVector (PrimState m) a) Source #

O(n) Yield a mutable copy of an immutable vector.

copy :: (Storable a, PrimMonad m) => MVector (PrimState m) a -> Vector a -> m () Source #

O(n) Copy an immutable vector into a mutable one. The two vectors must have the same length.